#!c:/perl/bin/perl.exe
use warnings;
use strict;
use diagnostics;

## A simple sub
print_it();

sub print_it {
	print "Look! A subroutine!\n";	
}


## A sub which takes arguments
reverse_it("Bolton");

sub reverse_it {
  my $string = shift @_;
  unless (defined $string) {
	die "The reverse_it subroutine requires a string";
  }
	
  print "A palindrome of $string would be ",scalar reverse ($string),"\n";
}


## Picking up arguments in different ways
my $bank_account = "1000";

innocent_sub($bank_account);
print "I have $bank_account in my account\n";

nasty_sub($bank_account);
print "I have $bank_account in my account\n"; # What

sub innocent_sub {
	my ($ammount) = @_;
	$ammount -= 500;
}

sub nasty_sub {
	$_[0] -= 500;
}


## Sending return values
my ($total,$count,$average) = number_stats(1,2,3,4,5,6);

print "Total=$total Count=$count Average=$average\n";

sub number_stats {
	my @numbers = @_;
	
	my $count = 0;
	my $total = 0;
	
	foreach my $number (@numbers) {
		++$count;
		$total += $number;
	}	
	
	my $average = $total/$count;
	return ($total,$count,$average);
}

